/*
Interactive JScript
Version 1.3
September 18, 2009
Copyright 2009 by Jamal Mazrui
GNU Lesser General Public License (LGPL)
*/

import Homer
import NetMatters
import Accessibility
import Microsoft.VisualBasic
import Microsoft.VisualBasic.Compatibility.VB6
import Microsoft.VisualBasic.ApplicationServices
import Microsoft.VisualBasic.Devices
import Microsoft.VisualBasic.FileIO
import Microsoft.VisualBasic.Logging
import Microsoft.VisualBasic.MyServices
import Microsoft.Win32
import System
import System.Collections
import System.Collections.ObjectModel
import System.Collections.Specialized
import System.ComponentModel
import System.Data
import System.Data.OleDb
import System.Diagnostics
import System.Drawing
import System.IO
import System.Media
import System.Net
import System.Reflection
import System.Runtime.InteropServices
import System.Text
import System.Text.RegularExpressions
import System.Threading
import System.Web
import System.Windows.Forms
import System.Xml

function weInit() {
try {
we = new ActiveXObject("WindowEyes.Application");
//output("Done!");
}
catch (x) {
output("Error!");
}
} // weInit function

function weSay(sText) {
//if (we != null) we.Speak(sText);
//return;

var oWE;
try {
oWE = new ActiveXObject("GWSpeak.Speak");
oWE.SpeakString(sText);
}
catch (x) {
return;
}
oWE = null;
} // WESay function

function evalCatch(oExp) {
try {
return eval(oExp, "unsafe");
}
catch (ex) {
//return ex.Message;
return undefined;
}
} // evalCatch function

function wrap(sText) {
var iMax = 60;
var sLines = sText.ToString();
var aLines = sLines.split("\r\n");
var sReturn = "";
for (var i = 0; i < aLines.length; i++) {
var sLine = aLines[i];
if (sLine.length > iMax) {
var aWords = sLine.split(" ");
sLine = "";
for (var j = 0; j < aWords.length; j++) {
var sWord = aWords[j];
if (sLine.concat(sWord).length > iMax) {
sReturn += sLine.TrimEnd() + "\r\n";
sLine = sWord + " ";
}
else sLine = sLine.concat(sWord) + " ";
}
}
sReturn += sLine.TrimEnd() + "\r\n";
}
return sReturn;
} // wrap function

function syntax(sText) {
var sWords =sText.ToString().Trim();
if (sWords.Length == 0) return "";

var aWords = sWords.Split(' ');
var jLength = aWords.Length;
var sReturn = aWords[0];
if (jLength == 1) return sReturn
sReturn += " = " ;
for (var j = 1; j < aWords.Length; j++) sReturn += aWords[j] + " ";
sReturn = sReturn.Replace("System.", "");
return sReturn
} // syntax method

function doc(o, s) {
try {
var t : Type;
//output(o.GetType());
if (o.GetType().ToString() == "System.RuntimeType") t = o;
else t = o.GetType();
//output(t.GetType());
var a;
if (s.length == 0) a = t.GetConstructors();
else a = t.GetMember(s, iBindingFlags);
for (var i = 0; i < a.length; i++) {
var mi = a[i];
var sText = new XmlComments(mi)
sText = sText.ToString();
sText = Regex.Replace(sText, "\\<.aram .*?ame.*?\"(.*?)\".*?\\>", "\r\n$1 = ");
sText = Regex.Replace(sText, "\\<see .*?T\\:(\\w+\\.\\w+).*?\\>", "$1");
sText = Regex.Replace(sText, "\\<.xception .*?T\\:(\\w+\\.\\w+).*?\\>", "\r\n$1 = ");
sText = sText.Replace("<returns>", "<returns>\r\nReturns ");
sText = Regex.Replace(sText, "\\<filterpriority\\>.*?\\</filterpriority\\>", "");
sText = Regex.Replace(sText, "\\<PermissionSet\\>.*?\\</PermissionSet\\>", "");
sText = Regex.Replace(sText, "\\<.*?\\>", "");
sText = sText.Replace("System.", "");
sText = wrap(sText);
var sSyntax = syntax(mi);
sSyntax = sSyntax.Replace("Void = .ctor", t.Name);
sText = sSyntax + "\r\n" + sText;
output(sText);
}
}
catch (ex) {
output(ex.Message);
}
} // doc function

function pause() {
weSay("Press any key to continue ...");
Console.Write("Press any key to continue ...");
Console.ReadKey();
Console.Clear();
} // pause function

function comCreate(sProgId) {
return Interaction.CreateObject(sProgId);
} // comCreate function

function comGet(sProgId) {
return Interaction.GetObject(sProgId);
} // comGet function

function getTypeName(iType) {
switch (iType) {
case 8192 :
return "Array";
case 11 :
//return "BOOL";
return "Boolean";
case 8 :
//return "BSTR";
return "String";
case 16384 :
return "ByRef"  ;
case 7 :
return "Date";
case 14 :
return "Decimal";
case 9 :
return "Dispatch";
case 0 :
return "Empty";
case 10 :
return "Error";
case 3 :
//return "I4";
return "Long";
case 1 :
return "Null";
case 27 :
return "SafeArray";
case 19 :
//return "UI4";
return "UnsignedLong";
case 13 :
return "Unknown";
case 12 :
return "Variant";
case 4096 :
return "Vector"  ;
case 24 :
return "Void";
}
} // getTypeName function

function getVarType(vtInfo) {
var sText = "";
var vt = vtInfo.VarType;
if (vt & VT_BYREF) sText += "ByRef ";
if (vt & VT_ARRAY) {
sText += "Array of ";
}
else if (vt &VT_VECTOR) {
sText += "Fixed size array of ";
}
//output("vt " +  vt);
var vtBase = vt & ~(VT_ARRAY | VT_VECTOR);
//output("vtBase " + vtBase);
if (vtBase) {
//output("variant " + typeof(vtInfo.TypedVariant));
//output("type " + vtInfo.TypedVariant.GetType());
//sText = sText + typeof(vtInfo.TypedVariant);
sText += getTypeName(vt);
}
else {
try {
sText += vtInfo.TypeInfo.Name;
}
catch (x) {
sText += "Unregistered External Type";
}
}
return sText;
} // getVarType function

function objects(o, sMatch, bDig) {
try {
var oTLI = Interaction.CreateObject("TLI.TLIApplication");
var oRef = null;
try {
oRef = oTLI.InterfaceInfoFromObject(o);
}
catch (x) {
oRef = oTLI.ClassInfoFromObject(o);
}
var oLibrary = oRef.Parent
oRef = null;
var oTypes = oLibrary.TypeInfos
var iTypeCount = oTypes.Count;
var sText = "";
for (var iType = 1; iType <= iTypeCount; iType++) {;
var oType = oTypes.Item(iType);
var iAttributes = oType.AttributeMask
if ((iAttributes & TYPEFLAG_FHIDDEN) || (iAttributes & TYPEFLAG_FRESTRICTED)) {
// Do nothing
}
else
{
var sText = oType.Name;
if (!bDig || ((sMatch.length == 0) || (sText.ToLower().IndexOf(sMatch.ToLower()) >= 0))) output(sText);
if (bDig) com(oType, sMatch, true);
}
}
}
catch (ex) {
}
} // objects function

function com(o, sMatch, bDig) {
try {
var bObjectSpoken = false;
var oTLI = Interaction.CreateObject("TLI.TLIApplication");
var oRef = null;
if (bDig) {
oRef = o;
}
else {
try {
oRef = oTLI.InterfaceInfoFromObject(o);
}
catch (x) {
oRef = oTLI.ClassInfoFromObject(o);
}
}

var iTypeKind = oRef.TypeKind;
var oMembers = oRef.Members;
var iMemberCount = oMembers.Count;
var sText = "";
for (var iMember = 1; iMember <= iMemberCount; iMember++) {;
var oMember = oMembers.Item(iMember);
var iAttributes = oMember.AttributeMask
var iDescKind = oMember.DescKind;
if ((iDescKind == DESCKIND_FUNCDESC) && ((iAttributes & FUNCFLAG_FHIDDEN) || (iAttributes & FUNCFLAG_FRESTRICTED))) {
// Do nothing
}
else if ((iDescKind == DESCKIND_VARDESC) && ((iAttributes & VARFLAG_FHIDDEN) || (iAttributes & VARFLAG_FRESTRICTED))) {
// Do nothing
}
//else if (sExcludeMembers.Index(oMember.Name) >= 0) {
// Do nothing
//}
else {
var oParams = oMember.Parameters;
var iParamCount = oParams.Count;
var sParams = "";
for (var iParam = 1; iParam <= iParamCount; iParam++) {;
var oParam = oParams.Item(iParam);
if (iParam > 1) sParams += ", ";
var sType = getVarType(oParam.VarTypeInfo);
if (oParam.Optional) sType = "Optional " + sType;
sParams += sType + " ";
sParams += oParam.Name;
if (oParam.Default) sParams += " = " + oParam.DefaultValue.ToString();
oParam = null;
};
var sLine;
if ((iDescKind == DESCKIND_VARDESC) && ((iTypeKind == TKIND_MODULE) || (iTypeKind == TKIND_ENUM))) {
sLine = oMember.Name + " = " + oMember.Value;
}
else {
var sType = getVarType(oMember.ReturnType);
sLine = sType + " = ";
sLine += oMember.Name;
if (sParams.length > 0) sLine += "(" + sParams + ")";
//if (sParams.length == 0 && iDescKind == DESCKIND_FUNCDESC) sLine += "()";
var iInvokeKind = oMember.InvokeKind
if ((sParams.length == 0) && ((iInvokeKind == INVOKE_EVENTFUNC) || (iInvokeKind == INVOKE_FUNC))) sLine += "()";
}

if ((sMatch.length == 0) || (sLine.ToLower().IndexOf(sMatch.ToLower()) >= 0)) {
if (!bObjectSpoken) {
sText += oRef.Name + "\r\n";
bObjectSpoken = true;
}
if (sLine.Trim().Length >= 0) sText += sLine + "\r\n";
}

oParams = null;
oMember = null;
}
}
// while (sText.IndexOf("\r\n\r\n\r\n") >= 0) sText = sText.Replace(sText, "\r\n\r\n\r\n", "\r\n\r\n");
if (sText.Trim().Length > 0) output(sText);
oMembers = null;
oRef = null;
oTLI = null;
//}
//catch (ex) {
//output(ex.Message);
//}
}
catch (ex) {
}
} // com function

function net(o) {
output("constructors") 
constructors(o);
output("");
output("events")
events(o);
output("");
output("fields")
fields(o);
output("");
output("methods")
methods(o);
output("");
output("properties")
properties(o);
} // net function

function constructors(o) {
var t;
if (o.GetType().ToString() == "System.RuntimeType") t = o;
else t = o.GetType();
var a = t.GetConstructors();
var s = "";
for (var i = 0; i < a.length; i++) s += a[i].ToString() +  "\n";
s = s.Replace("System.", "");
s = s.Replace("Void .ctor", t.Name);
output(s);
} // constructors function

function methods(o) {
var t;
if (o.GetType().ToString() == "System.RuntimeType") t = o;
else t = o.GetType();
var a = t.GetMethods();
var s = "";
for (var i = 0; i < a.length; i++) {
var sWords =a[i].ToString().Trim();
if (sWords.Length == 0) continue;
var aWords = sWords.Split(' ');
var sWords = "";
for (var j = 1; j < aWords.Length; j++) sWords += aWords[j] + " ";
s += aWords[0].Trim() + " = " + sWords.Trim() + "\r\n";
}
s = s.Replace("System.", "");
output(s);
} // methods function

function properties(o) {
var t;
if (o.GetType().ToString() == "System.RuntimeType") t = o;
else t = o.GetType();
var a = t.GetProperties();
var s = "";
for (var i = 0; i < a.length; i++) {
var sWords =a[i].ToString().Trim();
if (sWords == undefined || sWords.Length == 0) continue;
var aWords = sWords.Split(' ');
var sWords = "";
for (var j = 1; j < aWords.Length; j++) sWords += aWords[j] + " ";
s += aWords[0].Trim() + " = " + sWords.Trim() + "\r\n";
}
s = s.Replace("System.", "");
output(s);
} // properties function

function fields(o) {
var t;
if (o.GetType().ToString() == "System.RuntimeType") t = o;
else t = o.GetType();
var a = t.GetFields();
var s = "";
for (var i = 0; i < a.length; i++) s += a[i].ToString() +  "\n";
s = s.Replace("System.", "");
output(s);
} // fields function

function events(o) {
var t;
if (o.GetType().ToString() == "System.RuntimeType") t = o;
else t = o.GetType();
var a = t.GetEvents();
var s = "";
for (var i = 0; i < a.length; i++) s += a[i].ToString() +  "\n";
s = s.Replace("System.", "");
s = s.Replace("Void .ctor", t.Name);
output(s);
} // events function

function input() {
var sReturn = Console.ReadLine();
var sText = sPrompt.concat(sReturn);
if (bLog) File.AppendAllText(sLog, sText + "\r\n");
sHistory += sText + "\r\n";
return sReturn;
} // input function

function output(sText) {
try {
sText = sText.ToString();
}
catch (ex) {
return;
}
sText = sText.replace("Microsoft.JScript.Completion", "");
if (bLog) File.AppendAllText(sLog, sText + "\r\n");
sHistory += sText + "\n";
var aLines = sText.split("\n");
var iCount = aLines.length;
var iStart = 0;
var iLine = iStart;
while (iLine < iCount) {
sText = "";
while ((iLine - iStart) < Math.min(20, iCount)) {
sText += aLines[iLine] + "\r\n";
iLine++;
}
sText = Regex.Replace(sText, "^undefined\r*$", "", RegexOptions.Multiline);
//sText = sText.Replace("\r\nundefined\r\n", "\r\n");
weSay(sText);
Console.WriteLine(sText);
iStart = iLine;
if (bPauseOutput && (iLine < iCount - 1)) pause();
}

} // output function

var h = Acc.FindWindow("ConsoleWindowClass", "Interactive JScript");
var i:Int32 = h
if (i != 0) {
Acc.ForceWindow(h);
Interaction.AppActivate("Interactive JScript");
}
else {
var we = null;
if (Acc.IsWinEyesActive()) weInit();

var INVOKE_UNKNOWN = 0;
var INVOKE_FUNC = 1;
var INVOKE_PROPERTYGET = 2;
var INVOKE_PROPERTYPUT = 4;
var INVOKE_PROPERTYPUTREF = 8;
var INVOKE_EVENTFUNC = 16;
var INVOKE_CONST = 32;

var TKIND_ALIAS = 6;
var TKIND_COCLASS = 5;
var TKIND_DISPATCH = 4;
var TKIND_ENUM = 0;
var TKIND_INTERFACE = 3;
var TKIND_MAX = 8;
var TKIND_MODULE = 2;
var TKIND_RECORD = 1;
var TKIND_UNION = 7;

var DESCKIND_FUNCDESC = 1;
var DESCKIND_NONE = 0;
var DESCKIND_VARDESC = 2;

var sExcludeMembers = " QueryInterface GetTypeInfoCount GetTypeInfo GetIDsOfNames Invoke ";
var TYPEFLAG_FHIDDEN = 16;
var TYPEFLAG_FRESTRICTED = 512;

var FUNCFLAG_FHIDDEN = 64;
var FUNCFLAG_FRESTRICTED = 1;

var VARFLAG_FHIDDEN = 64;
var VARFLAG_FRESTRICTED = 128;

var VT_ARRAY = 8192;
var VT_BOOL = 11;
var VT_BSTR = 8;
var VT_BYREF = 16384  ;
var VT_DATE = 7;
var VT_DECIMAL = 14;
var VT_DISPATCH = 9;
var VT_EMPTY = 0;
var VT_ERROR = 10;
var VT_I4 = 3;
var VT_NULL = 1;
var VT_SAFEARRAY = 27;
var VT_UI4 = 19;
var VT_UNKNOWN = 13;
var VT_VARIANT = 12;
var VT_VECTOR = 4096  ;
var VT_VOID = 24;

var iBindingFlags = BindingFlags.Instance | BindingFlags.Static | BindingFlags.Public | BindingFlags.NonPublic;
var bPauseOutput = true;
var bLog = false;
var sLog = "";
var sHistory = "";
var sTitle = "Interactive JScript";
Console.Title = sTitle;
var sPrompt = "> ";
var sContinuePrompt = "_ ";
output(sTitle);
output("Enter help for options");

var bQuit = false;
var sInput = "";
var bContinue = false;
while (true) {
if (bContinue) {
weSay(sContinuePrompt);
Console.Write(sContinuePrompt);
sInput += "\r\n" + input();
}
else {
weSay(sPrompt);
Console.Write(sPrompt);
sInput = input();
}

sInput = sInput.replace(/(^\s*)|(\s*$)/g, "");

if (sInput.slice(-2) == ' _') {
sInput = sInput.substring(0,sInput.length-2)
bContinue = true;
continue;
}
else bContinue = false;

var aInput = sInput.split(" ");
var sCommand = aInput[0];
var sRest = "";
var sParam1 = "";
var sParam2 = "";
var sParam3 = "";
if (aInput.length > 1) {
for (var i = 1; i < aInput.length; i++) { 
if (i > 1) sRest += " ";
sRest += aInput[i];

if (i == 1) sParam1 = aInput[i];
else if (i == 2) sParam2 = aInput[i];
else if (i == 3) sParam3 = aInput[i];
} // for
} // if

var oRest;
try {
oRest = eval(sRest, "unsafe");
} 
catch (ex) {
}

switch (sCommand) {
case "weInit" :
weInit();
break;
case "clear" :
Console.Clear();
break;
case "clipboard" :
try {
var sText = Clipboard.GetText();
output(sText);
output(eval(sText, "unsafe"));
}
catch(ex) {
output(ex.Message);
}
break;
case "cls" :
Console.Clear();
break;
case "pause" :
if (sRest == "off") {
bPauseOutput = false;
}
else {
bPauseOutput = true;
}
break;
case "com" :
var iLength = sParam1.Length
sRest = sRest.Substring(iLength).Trim();
var oParam1 = eval(sParam1, "unsafe");
com(oParam1, sRest, false);
break;
case "objects" :
var iLength = sParam1.Length
sRest = sRest.Substring(iLength).Trim();
var oParam1 = eval(sParam1, "unsafe");
objects(oParam1, sRest, false);
break;
case "lib" :
var iLength = sParam1.Length
sRest = sRest.Substring(iLength).Trim();
var oParam1 = eval(sParam1, "unsafe");
objects(oParam1, sRest, true);
break;
case "doc" :
//doc(eval(sParam1, "unsafe"), sParam2);
doc(evalCatch(sParam1), sParam2);
break;
case "dos" :
var sCommand = sRest;
var process = new Process();
process.StartInfo.UseShellExecute = false;
process.StartInfo.RedirectStandardOutput = true;
process.StartInfo.RedirectStandardError = true;
process.StartInfo.CreateNoWindow = true;
process.StartInfo.FileName = "cmd.exe";
process.StartInfo.Arguments = "/c " + sCommand;

try {
process.Start();
}
catch (ex) {
output(ex.Message);
}

output(process.StandardError.ReadToEnd());
output(process.StandardOutput.ReadToEnd());
break;
case "exit" :
bQuit = true;
break;
case "history" :
switch (sRest) {
case "clear" :
sHistory = "";
break;
case "clipboard" :
try {
Clipboard.SetText(sHistory);
}
catch (ex) {
output(ex.Message);
}
break;
case "show" :
output(sHistory);
break;
}
case "eval" :
switch (sRest) {
case "clipboard" :
try {
var sText = Clipboard.GetText();
output(sText);
output(eval(sText, "unsafe"));
}
catch(ex) {
output(ex.Message);
}
break;
default :
var sFile = sRest;
if (!File.Exists(sFile)) {
output("File not found!");
break;
}

try {
var sText = File.ReadAllText(sFile);
output(sText);
output(eval(sText, "unsafe"));
}
catch(ex) {
output(ex.Message);
}
break;
}
break;
case "log" :
switch (sRest) {
case "clipboard" :
if (!File.Exists(sLog)) {
output("No log file!");
break;
}
try {
var sText = File.ReadAllText(sLog);
Clipboard.SetText(sText);
output("Done!");
}
catch (ex) {
output(ex.Message);
}
break;
case "off" :
bLog = false;
break;
case "on" :
if (!File.Exists(sLog)) {
output("No log file!  Enter the command");
output("log FileName");
break;
}
bLog = true;
break;
case "show" :
Console.WriteLine("log " + (bLog ? "on" : "off") + " " + sLog);
if (File.Exists(sLog)) {
var sText = File.ReadAllText(sLog);
Console.WriteLine(sText);
}
break;
default :
sLog = sRest;
try {
if (File.Exists(sLog)) File.Delete(sLog);
File.WriteAllText(sLog, "");
bLog = true;
}
catch (ex) {
output(ex.Message);
break;
}
}
break;
case "help" :
output("Interactive JScript 1.2 by Jamal Mazrui");
output("");
output("Type a JScript statement, followed by Enter");
output("(a closing semicolon is not needed).");
output("Use UpArrow to repeat a command.");
output(" End a line of input with a space and underline ( _) to continue");
output("a multiline block of code.");
output("The prompt then changes from a > to _ character.");
output("");
output("Most classes of the .NET Framework 2.0 may be used in expressions.");
output("Variable types are inferred.");
output("To ease typing, the following namespaces are imported");
output("(there classes may be referenced without a namespace prefix):");
output("Accessibility");
output("Microsoft.VisualBasic");
output("System");
output("System.Collections");
output("System.ComponentModel");
output("System.Data");
output("System.Diagnostics");
output("System.Drawing");
output("System.IO");
output("System.Net");
output("System.Reflection");
output("System.Runtime.InteropServices");
output("System.Text");
output("System.Text.RegularExpressions");
output("System.Web");
output("System.Windows.Forms");
output("System.Xml");
output("");
if (bPauseOutput) pause()
output("In addition, several built-in commands and functions are available.");
output("A command name is lower case, with a space before each argument,");
output("and no quotes around it.  A function name is lower camel case");
output("(words after the first are capitalized).");
output("");
output("quit = end this program");
output("cls = clear the screen");
output("eval FileName = execute a JScript file");
output("eval clipboard = execute JScript code on the clipboard");
output("cmd = pass any statement to the Windows command interpreter (cmd.exe)");
output("dos = execute a console-mode command and display its output");
output("log FileName = log output to a file");
//output("log show = display the log file");
output("log off = suspend logging");
output("pause on = pause output after the screen fills (default)");
output("pause off = continue output after the screen fills");
output("log on = continue logging");
//output("log clipboard = copy the log file to the clipboard");
output("net Type = list members of .NET Type");
output("constructors Type = list its constructors only");
output("events Type = list its events only");
output("fields Type = list its fields only");
output("methods Type = list its methods only");
output("properties Type = list its properties only");
output("com Object Match = list members of COM Object, optionally matching a substring");
output("objects Object Match = list objects in its library, optionally matching a substring");
output("lib Object Match = list objects and members in its library, optionally matching a substring");
output("dir Type/Object = directory of members of either .NET Type or COM Object");
output("doc Type = documentation for constructors of .NET Type");
output("doc Type Member = documentation for Member of .NET Type");
output("comCreate(sProgID) = alias for new ActiveXObject(sProgID)");
output("output(Object) = alias for Console.WriteLine(Object)");
output("");
output("If Window-Eyes is running, its Application object is ");
output("automatically assigned to the we variable for typing convenience.");
break;
case "quit" :
bQuit = true;
case "cmd" :
var sCommand = "cmd.exe /c " + sRest;
try {
Interaction.Shell(sCommand, AppWinStyle.NormalFocus, false, -1);
}
catch (ex) {
output(ex.Message);
}
break;
case "events" :
events(sRest);
break;
case "constructors" :
constructors(oRest);
break;
case "events" :
events(oRest);
break;
case "fields" :
fields(oRest);
break;
case "methods" :
methods(oRest);
break;
case "properties" :
properties(oRest);
break;
case "net" :
net(oRest);
break;
case "dir" :
if (oRest.GetType().ToString() == "System.__ComObject") com(oRest, "", false);
else net(oRest);
break;
default :
try {
output(eval(sInput, "unsafe"));
}
catch(ex) {
// output(ex.Message);
output(ex.description);
}
break;
} // switch

if (bQuit) break;
} // while
} // ForceWindow

